#pragma once
#ifndef CHANNEL_2_DEFINES_H
#define CHANNEL_2_DEFINES_H

//#########################################################
// Defines fuer die Protokollversion 2

// Fehler
/*
#define ERR_NO               0 // kein Fehler
#define ERR_COM_OPEN         1 // Serielle Schnitstelle kann nicht geöffnet werden
#define ERR_NO_COM           2 // Gerät antwortet nicht
#define ERR_WRITE            3 // Fehler beim schreiben in Gerät
#define ERR_READ             4 // Fehler beim lesen aus Gerät
#define ERR_FILE_OPEN        5 // File für Ablage der Daten kann nicht geöffnet werden
#define ERR_CRC              6 // CRC-Fehler beim lesen der Daten aus Gerät
#define ERR_ADD_SE           7 // Fehler bei Sender-/Empfänger Adresse
#define ERR_BEFEHL_S4        8
#define ERR_FORMAT          10 // Datensatz-Format falsch im  TB
#define ERR_ABBRUCH         12 // Daten lesen von Anwender abgebrochen weil Datei bereits vorhenden
#define ERR_UNBEKANNT       13
#define ERR_DAT_WRITE       14 // Schreibbefehl wurde von Gerät nicht akzeptiert
#define ERR_WRITE_CNT       15 // Anzahl der geschriebenen Byte zu klein
#define ERR_BEDIEN_STOP     16 // Bedienung kann nicht angehalten werden
#define ERR_TYP_UNBEKANNT   17 // Typ der Kommunikation Schicht 2 unbekannt
*/

// Parameter der Kommunikation Applikationsschicht
#define A_MAX_DATEN        255 // max. Datenbyte in einem Paket 
#define A_VERSUCHE           4 // Anzahl Versuche ein Paket zu verschicken
#define A_VERSUCHE_OMB       3 // Anzahl Versuche ein Paket zu verschicken OldMB
#define A_VERSUCHE_PENDING  10 // Anzahl Versuche ein Paket zu verschicken OldMB

// Parameter der Verbindungsschicht
#define V_MAX_PAKET      0x600 // max. Anzahl Byte eines kompletten Pakets
#define V_KOPF               9 // Paketkopf in Byte (endet mit Time to live)
#define V_O_AD_ABSENDER_S2   2 // Schicht 2
#define V_O_LAENGE           4
#define V_O_B_S2             6 // Befehl Schicht 2
#define V_O_PAKET_NR         7
#define V_O_TIME_TO_LIVE     8
#define V_O_B_S3             9 // Befehl Schicht 3
#define V_O_ANZ_BLOECKE     10
#define V_O_AKT_BLOCK	    11
#define V_O_AD_ABSENDER_S4  12 // Schicht 4 
#define V_O_B_S4            14
#define V_O_ADD             15
#define V_O_DATEN           19

// Schicht 2
// Befehle
#define B_S2_NO                  0x01 // keine besondere Bedeutung

// Befehle Schicht 3
#define B_S3_NO           0x01 // keine besondere Bedeutung
// Befehle Schicht 3
#define B_S4_LESEN        0x01 // Daten lesen
#define B_S4_NEWMB        0x04 // Neues Modbusverfahren

// Bits im Befehl
#define BB_S4_ANTWORT     0x80 // Antwort auf Befehl
#define BB_S4_ANFRAGE     0x40 // Antwort gewünscht
#define BB_S4_ERROR       0x20 // Antwort enthält Fehlernummer (2Byte)

#endif

