/**
* @file  file_display_colors.h
* @brief Schnittstelle fuer die Klasse FileDisplayColors.
*/
//////////////////////////////////////////////////////////////////////
#pragma once
#ifndef FILE_DISPLAY_COLORS_H
#define FILE_DISPLAY_COLORS_H

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

// Verwaltungsklasse fuer Datei
#include "file_intel_hex.h"
// 16bit/32bit CRC
#include "common/crc.h"

// Strukturdefinitionen
#include "interface/display_colors_structs.h"

// Maximale Anzahl Datenbyte (512Byte)
#define MAX_MEM_DISPLAYCOLORS   0x200

// Maximale Anzahl DisplayColors
#define MAX_DISPLAYCOLORS   100

class FileDisplayColors : public FileIntelHex
{
public:
    FileDisplayColors();
    virtual ~FileDisplayColors();

    // Verwaltungsstrukturen fuer Farbstrukturen
    DISPLAYCOLORNODE *m_pDisplayColorsNode;
    DISPLAYCOLOR     *m_pDisplayColors[MAX_DISPLAYCOLORS];

public:
    void resetData();
    bool load( const std::string &filePath );
    bool save( const std::string &filePath, bool appendToFile = false, bool appendEndLine = true );
    void Init(unsigned char count);
    int SetDisplayColor(int idx, DISPLAYCOLOR tk);
    DISPLAYCOLOR GetDisplayColor(int idx);
    int GetDisplayColorCount()
    {
        return m_pDisplayColorsNode->cnt;
    }
};

#endif

