#pragma once
#ifndef DISPLAY_FONTS_STRUCTS_H
#define DISPLAY_FONTS_STRUCTS_H

/*!
    \brief Hält die grundlegenden Informationen über folgende @ref FONT Strukturen.
*/
struct FONTNODE
{
    unsigned char version; //!< Versionserkennung
                           //!< Versionsnummer 1: Basisstand
    unsigned char cnt;     //!< Anzahl folgender @ref FONT Strukturen der Zeichensätze.
    unsigned char temp[2]; //!< Reserve
    unsigned int ptrFontArray; //!< Offset auf ein Array von 32bit Offsetwerten zu den einzelnen @ref FONT Strukturen.
};

/*!
    \brief Hält die Information über einen Zeichensatz.
*/
struct FONT
{
    unsigned char version; //!< Versionserkennung
                           //!< Versionsnummer 1: Basisstand
    char name[32];         //!< Name des Zeichensatzes
    unsigned char type;    //!< Zeichensatztyp; 0 = Systemzeichensatz, 1 = Benutzerzeichensatz (vorgesehen)
    unsigned short bytesPerChar; //!< Bytes pro Zeichen (gilt für jedes Zeichen des Zeichensatzes)
    unsigned char linesPerChar;  //!< Zeilen pro Zeichen (-"-)
    unsigned char temp[3];       //!< Reserve
    unsigned int crc;            //!< Prüfsumme über die 256 Byte der Zeichentabelle inkl. Daten der Character.
    unsigned int size;           //!< Grösse des Zeichensatzes in Byte. Daten der Character.
    unsigned int ptrTable;       //!< Offset auf die 256 Byte (feste Größe) große Zeichentabelle.
    unsigned int ptrCharacter;   //!< Offset auf die Daten des ersten Zeichens.
};

#endif
